unit mzscheme;

interface

uses SysUtils;

//   .    dll    
//  
const mzlibrary = 'libmzsch352_000.dll';
      gclibrary = 'libmzgc352_000.dll';
type
  PMZChar = PChar;
  PScheme_Object = Pointer;
  PScheme_Env = Pointer;  
  PLong = ^Longint;

var Env: PScheme_Env;  //   
    scheme_true: PScheme_Object;   //#t
    scheme_false: PScheme_Object;   //#f
    scheme_null: PScheme_Object;   //null

// .  ,    -
//  stdcall,  cdecl
function scheme_basic_env: PScheme_Env;  cdecl; external mzlibrary;
function scheme_eval_string(str: PChar; env: PScheme_Env): PScheme_Object;  cdecl; external mzlibrary;
function scheme_display_to_string(obj: PScheme_Object; len: PLong): PChar;  cdecl; external mzlibrary;

//,    
function SchemeObjectAsString(obj: PScheme_Object): String;
function SchemeExec(Expr: String): String;

implementation

function SchemeObjectAsString;
var PC: PChar;
    L: Longint;
begin
  Result := '';
  PC := scheme_display_to_string(Obj, @L);
  SetString(Result, PC, L);
end;

function SchemeExec;
var Obj: PScheme_Object;
begin
  Obj := scheme_eval_string(PChar(Expr), Env);
  Result := SchemeObjectAsString(Obj);
end;

initialization
//  
  Env :=  scheme_basic_env;
// #t, #f  null -       
  scheme_true :=  scheme_eval_string('#t', Env);
  scheme_false :=  scheme_eval_string('#f', Env);
  scheme_null :=  scheme_eval_string('null', Env);
end.


